(function ($, Drupal) {
  Drupal.behaviors.customWebformHandler = {
    ids: [],
    attach: function (context, settings) {
      let that = this;
      $(once('ytarget-goal-submit', 'form[data-ytarget-goal]', context)).each(function () {
        const $form = $(this);
        const goal = $form.data('ytarget-goal');
        const imId = $form.data('ytarget-mid');
        const id = $form.attr('id');
        that.ids.push(id.replace(/-/g, '_'));
        $form.on('submit', function (e) {
          if ($form.hasClass('ytarget-goal-sent')) {
            return;
          }

          e.preventDefault();

          ym(imId, 'reachGoal', goal, {}, function () {
            $form.addClass('ytarget-goal-sent');
            $form.off('submit').submit();
          });
        });
      });
      if ($(once('ytarget-goal', 'body')).length) {
        $(document).ajaxComplete(function (event, xhr, settings) {
          const params = new URLSearchParams(settings.data);
          const formId = params.get('form_id');

          if (that.ids.includes(formId)) {
            const fid = formId.replace(/_/g, '-');
            const $form = $('.' + formId.replace(/_/g, '-'));
            const goal = $form.data('ytarget-goal');
            const imId = $form.data('ytarget-mid');
            ym(imId, 'reachGoal', goal, {});
          }
        });
      }

      // AJAX-отправка (Webform AJAX)
      $(once('ym-goal-ajax', document)).on('webformSubmissionSubmit', function (event, $form) {
        const goal = $form.data('ytarget-goal');
        const imId = $form.data('ytarget-mid');
        if (!goal || $form.hasClass('ytarget-goal-sent')) {
          return;
        }

        event.preventDefault();

        ym(imId, 'reachGoal', goal, {}, function () {
          $form.addClass('ytarget-goal-sent');
          $form.trigger('submit');
        });
      });
    },
  };
})(jQuery, Drupal);
