<?php

namespace Drupal\ytarget\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Configure ytarget settings.
 */
class YtargetSettingsFrom extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'ytarget_forms_settings';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['ytarget.settings'];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('ytarget.settings');

    $form['ytarget_id'] = [
      '#type' => 'number',
      '#title' => t('Metrika counter ID'),
      '#required' => TRUE,
      '#default_value' => $config->get('ytarget_id'),
      '#description' => t('Type yndex metrica counter numeric id.'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->config('ytarget.settings')
      ->set('ytarget_id', $form_state->getValue('ytarget_id'))
      ->save();

    parent::submitForm($form, $form_state);
  }

}
